#include <stdio.h>
#include <string.h>
#pragma hdrstop

#define STRICT
#include <windows.h>

#include "file.h"
#include "raw2nef.h"

#ifdef _MSC_VER

#include <stdlib.h> // __argc, __argv

#else//_MSC_VER

#include <dos.h> // _argc, _argv
#define __argv _argv
#define __argc _argc

#endif//_MSC_VER

extern const char* program;

void error(const char* mess)
{
   MessageBox(NULL, mess, program, MB_ICONSTOP|MB_OK);
}

class TTempFile
{
   const char* fn;
public:
   TTempFile(const char* _fn) : fn(_fn) {}
   ~TTempFile() { if(fn && fn[0]) DeleteFile(fn); }
};

int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int )
{
   int ret = 1;
   char temp[MAX_PATH];
   char out[MAX_PATH];

   if( !GetTempPath(sizeof temp, temp ) )
      { error( "Cannot get temporary folder" ); return ret; }

   if( !GetTempFileName(temp, "NEF", 0, out) )
      { error( "Cannot get temporary file" ); return ret; }

   if( !freopen(out, "wt", stdout) )
      { error( "Cannot redirect stdout" ); return ret; }

   TRaw2Nef raw2nef;

   if( raw2nef.raw_to_nef(__argc, __argv) )
      ret = 0;

   freopen("nul", "wt", stdout);

   TTempFile temp_file( out );
   TFile in = fopen(out, "rb");
   if( !in )
      { error( "Cannot open message file" ); return ret; }

   fseek( in, 0, SEEK_END );
   int len = ftell( in );
   if( len != 0 )
   {
      fseek( in, 0, SEEK_SET );
      char* mess = new char[len+1];

      if( !mess )
         { error( "Cannot show messages" ); return ret; }

      fread( mess, len, 1, in );
      mess[len] = '\0';

      int flags = MB_OK;
      if( strstr(mess, "error") )
         flags |= MB_ICONERROR;
      else
      if( strstr(mess, "warning") )
         flags |= MB_ICONWARNING;
      else
         flags |= MB_ICONINFORMATION;

      MessageBox(NULL, mess, program, flags);
   }
   return ret;
}

